//
//  MyDocument.m
//  X Word : an 8 line Graphics Enabled Word Processor
//
//  Created by Andrew Stone on Wed Feb 06 2002.
//  Enhanced by Tom Harrington on Wed Aug 07 2002.
//

#import "MyDocument.h"

@implementation MyDocument

- (NSString *)windowNibName
{
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    if ([textType isEqualToString:NSRTFDPboardType])
        [text replaceCharactersInRange:NSMakeRange(0,[[text string] length])                                                                             withRTFD:textData];
    else if ([textType isEqualToString:NSRTFPboardType])
        [text replaceCharactersInRange:NSMakeRange(0,[[text string] length]) withRTF:textData];
}

#define Whole_Range NSMakeRange(0,[[text string] length])

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
	if ([aType isEqualToString:NSRTFDPboardType]) {
		[textData release];
		textData = [[text RTFDFromRange:Whole_Range] retain];
		return textData;
	}
	else if ([aType isEqualToString:NSRTFPboardType]) {
		[textData release];
		textData = [[text RTFFromRange:Whole_Range] retain];
		return textData;
	}
    return nil;
}


// the nib has not loaded yet - so we hold on to the new stuff!
- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    textData = [data retain];
    textType = [aType retain];
    return YES;
}

- (void)dealloc
{
    [textData release];
    [textType release];
    [super dealloc];
}

// this allows you to save as PDF!
- (IBAction)printDocument:(id)sender
{
    [text print:sender];
}

// HOMEWORK:
// if you want your RTFD files to be openable by TextEdit - you'll
// have to implement these - see NSDocument and NSFileWrapper for more info:
//- (NSFileWrapper *)fileWrapperRepresentationOfType:(NSString *)type;
//- (BOOL)loadFileWrapperRepresentation:(NSFileWrapper *)wrapper ofType:(NSString *)type;
    // These APIs are intended for documents that are stored as file wrappers using the NSFileWrapper class.  By default, these methods call the NSData based API above.  The default implementation only handles regular file file wrappers.

@end
